unit ColComboTest;

// Demo to show some of the possibilities with ComboboxCol
// Claus Møller 12.12.2022

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ColorBox,
  Buttons, comboboxcol;

type

  { TColComboDemoForm }

  TColComboDemoForm = class(TForm)
    BitBtn1: TBitBtn;
    ButtonFont2: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    ColorBox1: TColorBox;
    Comboboxcol1: TComboboxcol;
    Edit1: TEdit;
    EditColumn: TEdit;
    FontDialog1: TFontDialog;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    procedure BitBtn1Click(Sender: TObject);
    procedure ButtonFont2Click(Sender: TObject);
    procedure CheckBox1Change(Sender: TObject);
    procedure CheckBox2Change(Sender: TObject);
    procedure ColorBox1Change(Sender: TObject);
    procedure Edit1EditingDone(Sender: TObject);
    procedure EditColumnEditingDone(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private

  public

  end;

var
  ColComboDemoForm: TColComboDemoForm;

implementation

{$R *.frm}

{ TColComboDemoForm }

procedure TColComboDemoForm.FormCreate(Sender: TObject);
begin
  // Init
(*  Comboboxcol1.Clear;
  Comboboxcol1.HighlightColor        := clHighLight;

  // Insert 3 columns
  Comboboxcol1.Columns.Add;
  Comboboxcol1.Columns.Add;
  Comboboxcol1.Columns.Add;
  // Format the columns
  Comboboxcol1.Columns.Items[0].Color      := clSilver;
  Comboboxcol1.Columns.Items[0].Visible    := True;
  Comboboxcol1.Columns.Items[0].Alignment  := taCenter;
  Comboboxcol1.Columns.Items[0].Width      := 250;
  *)
  Comboboxcol1.AddRow;
  Comboboxcol1.AddRow;
  Comboboxcol1.AddRow;
  Comboboxcol1.Cells[0,0] := 'ComboCol is here';
  Comboboxcol1.Cells[1,0] := 'Free';
  Comboboxcol1.Cells[2,0] := 'Smart';
  Comboboxcol1.Cells[0,1] := 'Pascal';
  Comboboxcol1.Cells[1,1] := 'For';
  Comboboxcol1.Cells[2,1] := 'Ever';
  Comboboxcol1.Cells[0,2] := 'Denmark';
  Comboboxcol1.Cells[1,2] := 'Is';
  Comboboxcol1.Cells[2,2] := 'Nice';

  Comboboxcol1.ItemIndex:=0;
  // ShowMessage('Index of For is ' + IntToStr(Comboboxcol1.IndexInColumnOf(1,'For')));
  Comboboxcol1.EditColumn := -1;
end;

procedure TColComboDemoForm.CheckBox1Change(Sender: TObject);
begin
  If CheckBox1.Checked Then
    Comboboxcol1.ShowColSeparators := True
  Else
    Comboboxcol1.ShowColSeparators := False;
end;

procedure TColComboDemoForm.ButtonFont2Click(Sender: TObject);
begin
  If FontDialog1.Execute Then
    Begin
      Comboboxcol1.Columns.Items[2].Font := FontDialog1.Font;
    end;
end;

procedure TColComboDemoForm.BitBtn1Click(Sender: TObject);
begin
  Close;
end;

procedure TColComboDemoForm.CheckBox2Change(Sender: TObject);
begin
  If CheckBox2.Checked Then
    Comboboxcol1.Columns.Items[2].Visible:=False
  Else
    Comboboxcol1.Columns.Items[2].Visible:=True;
end;

procedure TColComboDemoForm.ColorBox1Change(Sender: TObject);
begin
  Comboboxcol1.Columns.Items[1].Color   := Colorbox1.Selected;
end;

procedure TColComboDemoForm.Edit1EditingDone(Sender: TObject);
begin
  Comboboxcol1.Columns.Items[0].Width   := StrtoInt(Edit1.Text);
end;

procedure TColComboDemoForm.EditColumnEditingDone(Sender: TObject);
begin
  Comboboxcol1.EditColumn := StrToInt(EditColumn.Text);
end;

end.

